Difference between revisions of "Documentation/4.2/Developers/Build Instructions/Prerequisites/Qt"

From Slicer Wiki
Jump to: navigation, search
(Prepend documentation/versioncheck template. See http://na-mic.org/Mantis/view.php?id=2887)
 
(9 intermediate revisions by 4 users not shown)
Line 1: Line 1:
 +
<noinclude>{{documentation/versioncheck}}</noinclude>
 
= Binary vs build-from-source ? =
 
= Binary vs build-from-source ? =
  
Line 17: Line 18:
 
=== Debug (32 and 64-bit) or Release (64-bit) ===
 
=== Debug (32 and 64-bit) or Release (64-bit) ===
  
* You have to build Qt from source. See [[#Download_links]] and [[#Installation_instruction]]
+
* You have to build Qt from source. See [[#Download_links]] and [[#Windows_4|Build instructions]]
  
 
{{note}} Using the Qt Designer on Windows requires that the Slicer plugins are [http://doc.trolltech.com/4.6/deployment-plugins.html#debugging-plugins|compiled in the same mode as Qt]. If Qt was compiled in Release mode (default), Slicer would have to be compiled in Release mode as well. However if Qt is compiled in Debug mode only, Slicer has to be compiled in Debug too. When Qt is in "Release and Debug" mode only the Release version of Designer.exe is generated, Slicer would have to be compiled in Release. So for developers, the <b>Debug mode is recommended</b>, this is why we detail the compilation of Qt below.
 
{{note}} Using the Qt Designer on Windows requires that the Slicer plugins are [http://doc.trolltech.com/4.6/deployment-plugins.html#debugging-plugins|compiled in the same mode as Qt]. If Qt was compiled in Release mode (default), Slicer would have to be compiled in Release mode as well. However if Qt is compiled in Debug mode only, Slicer has to be compiled in Debug too. When Qt is in "Release and Debug" mode only the Release version of Designer.exe is generated, Slicer would have to be compiled in Release. So for developers, the <b>Debug mode is recommended</b>, this is why we detail the compilation of Qt below.
Line 56: Line 57:
 
|-
 
|-
 
! bgcolor="#FFFFCC" | [http://get.qt.nokia.com/qt/source/ Qt source link]
 
! bgcolor="#FFFFCC" | [http://get.qt.nokia.com/qt/source/ Qt source link]
|align="center" colspan="2"| [http://get.qt.nokia.com/qt/source/qt-everywhere-opensource-src-4.7.4.tar.gz 4.7.4]  
+
|align="center" colspan="2"| [ftp://ftp.qt-project.org/qt/source/qt-everywhere-opensource-src-4.7.4.tar.gz 4.7.4]  
|style="background-color:#C0C0C0;" align="center" colspan="1"| <del>[http://get.qt.nokia.com/qt/source/qt-everywhere-opensource-src-4.7.4.tar.gz 4.7.4]</del>
+
|style="background-color:#C0C0C0;" align="center" colspan="1"| <del>[ftp://ftp.qt-project.org/qt/source/qt-everywhere-opensource-src-4.7.4.tar.gz 4.7.4]</del>
|align="center" colspan="1"| [http://get.qt.nokia.com/qt/source/qt-everywhere-opensource-src-4.7.4.tar.gz 4.7.4]
+
|align="center" colspan="1"| [ftp://ftp.qt-project.org/qt/source/qt-everywhere-opensource-src-4.7.4.tar.gz 4.7.4]
|align="center" colspan="2"| [http://get.qt.nokia.com/qt/source/qt-everywhere-opensource-src-4.7.4.zip 4.7.4]
+
|align="center" colspan="2"| [ftp://ftp.qt-project.org/qt/source/qt-everywhere-opensource-src-4.7.4.zip 4.7.4]
|align="center" colspan="2"| [http://get.qt.nokia.com/qt/source/qt-everywhere-opensource-src-4.7.4.zip 4.7.4]
+
|align="center" colspan="2"| [ftp://ftp.qt-project.org/qt/source/qt-everywhere-opensource-src-4.7.4.zip 4.7.4]
 
|-
 
|-
 
! bgcolor="#FFFFCC" | [http://get.qt.nokia.com/qt/source/  Qt binary link]
 
! bgcolor="#FFFFCC" | [http://get.qt.nokia.com/qt/source/  Qt binary link]
Line 66: Line 67:
 
|align="center" colspan="1"| [http://sw.nokia.com/id/14b2039c-0e1f-4774-a4f2-9aa60b6d5313/Qt_SDK_Lin64_offline SDK-1.2]
 
|align="center" colspan="1"| [http://sw.nokia.com/id/14b2039c-0e1f-4774-a4f2-9aa60b6d5313/Qt_SDK_Lin64_offline SDK-1.2]
 
|style="background-color:#C0C0C0;" align="center" colspan="1"| <del>[http://get.qt.nokia.com/qt/source/qt-mac-carbon-opensource-4.7.0.dmg carbon_4.7.0]</del>
 
|style="background-color:#C0C0C0;" align="center" colspan="1"| <del>[http://get.qt.nokia.com/qt/source/qt-mac-carbon-opensource-4.7.0.dmg carbon_4.7.0]</del>
|align="center" colspan="1"| [ftp://ftp.qt.nokia.com/qt/source/qt-mac-opensource-4.7.4.dmg 4.7.4] <br> [ftp://ftp.qt.nokia.com/qt/source/qt-mac-opensource-4.7.4-debug-libs.dmg 4.7.4 (optional: debug libs)]  
+
|align="center" colspan="1"| [ftp://ftp.qt-project.org/qt/source/qt-mac-opensource-4.7.4.dmg 4.7.4] <br> [ftp://ftp.qt-project.org/qt/source/qt-mac-opensource-4.7.4-debug-libs.dmg 4.7.4 (optional: debug libs)]  
  
|align="center" colspan="1"| [http://get.qt.nokia.com/qt/source/qt-win-opensource-4.7.4-vs2008.exe 4.7.4]
+
|align="center" colspan="1"| [ftp://ftp.qt-project.org/qt/source/qt-win-opensource-4.7.4-vs2008.exe 4.7.4]
|align="center" colspan="1"| -
+
|align="center" colspan="1"| (src build only)
|align="center" colspan="1"| [http://get.qt.nokia.com/qt/source/qt-win-opensource-4.7.4-vs2008.exe 4.7.4]
+
|align="center" colspan="1"| [ftp://ftp.qt-project.org/qt/source/qt-win-opensource-4.7.4-vs2008.exe 4.7.4]
|align="center" colspan="1"| -
+
|align="center" colspan="1"| (src build only)
 
|}
 
|}
  
 +
Note:  You must first [https://sso.developer.nokia.com log in to your Nokia Developer account].  Otherwise these links may appear to be broken.
 
== Installation instruction ==
 
== Installation instruction ==
  
Line 79: Line 81:
  
 
See [[Documentation/{{documentation/version}}/Developers/Build_Instructions/Prerequisites/Qt/Instal_QtSDK1.2_Offline_Linux_64|Qt installation guide (4.7.4, Linux, 64-bit, Offline)]]
 
See [[Documentation/{{documentation/version}}/Developers/Build_Instructions/Prerequisites/Qt/Instal_QtSDK1.2_Offline_Linux_64|Qt installation guide (4.7.4, Linux, 64-bit, Offline)]]
 +
 +
For debian/ubuntu you should be able to use:
 +
sudo apt-get install qt4-dev-tools
 +
which at the time of this writing will install qt4.8.1.  To use this, you must override the cmake option which is set to 4.7.4.
  
 
=== Mac ===
 
=== Mac ===
Line 93: Line 99:
  
 
* '''Qt 4.6.x''' on windows (and possibly in linux/mac): No image base64 support in QLabel/QTooltips (work around exists though)
 
* '''Qt 4.6.x''' on windows (and possibly in linux/mac): No image base64 support in QLabel/QTooltips (work around exists though)
* '''Qt 4.8''' does not work with PythonQt in slicer4 - suggested version is 4.7.4
 
  
 
=== Linux ===
 
=== Linux ===
Line 179: Line 184:
 
#* When asked, choose open source license type (o), then accept the license (y)
 
#* When asked, choose open source license type (o), then accept the license (y)
 
#* Note: the option <code>-prefix</code> doesn't work on Windows.
 
#* Note: the option <code>-prefix</code> doesn't work on Windows.
#* Note: According to [http://qt.nokia.com/doc/4.7/supported-platforms.html] Qt does not support msvc2008 on windows xp.  However, running <code>configure.exe</code> with no <code>-platform</code> argument seems to work. If you run configure with the <code>-platform</code> argument first by mistake, and if <code>configure -clean</code> doesn't work, then you may need to start from a fresh extraction from the .zip archive before running <code>configure.exe</code> again with no <code>-platform</code>, unless you can run <code>nmake</code> with the config clean target.
+
#* Note: According to [http://qt-project.org/doc/qt-4.7/supported-platforms.html] Qt does not support msvc2008 on windows xp.  However, running <code>configure.exe</code> with no <code>-platform</code> argument seems to work. If you run configure with the <code>-platform</code> argument first by mistake, and if <code>configure -clean</code> doesn't work, then you may need to start from a fresh extraction from the .zip archive before running <code>configure.exe</code> again with no <code>-platform</code>, unless you can run <code>nmake</code> with the config clean target.
 
#* Note: for Microsoft Visual Studio 2010 users, Qt 4.6.3 is hard to configure with MSVC2010, use Qt 4.7.x instead. Build with <code>set QMAKESPEC=win32-msvc2010</code> and <code>configure -platform win32-msvc2010  -debug</code>
 
#* Note: for Microsoft Visual Studio 2010 users, Qt 4.6.3 is hard to configure with MSVC2010, use Qt 4.7.x instead. Build with <code>set QMAKESPEC=win32-msvc2010</code> and <code>configure -platform win32-msvc2010  -debug</code>
 
# run <code>nmake</code>
 
# run <code>nmake</code>
 
#* Note: building with webkit support requires that <i>src/3rdparty/webkit/WebCore/tmp/moc/{debug,release}_shared/mocinclude.tmp</i> be removed. else you will get linker errors like <code>QNetworkReplyHandler.obj : error LNK2001: unresolved external symbol "public: virtual struct QMetaObject const * __thiscall WebCore::FormDataIODevice::metaObject(void)const (?metaObject@FormDataIODevice@WebCore@@UBEPBUQMetaObject@@XZ)</code>
 
#* Note: building with webkit support requires that <i>src/3rdparty/webkit/WebCore/tmp/moc/{debug,release}_shared/mocinclude.tmp</i> be removed. else you will get linker errors like <code>QNetworkReplyHandler.obj : error LNK2001: unresolved external symbol "public: virtual struct QMetaObject const * __thiscall WebCore::FormDataIODevice::metaObject(void)const (?metaObject@FormDataIODevice@WebCore@@UBEPBUQMetaObject@@XZ)</code>
 
#* Note: If you encounter the following error <code>api\qscriptextensionplugin.h(43): Error: Undefined interface,</code>, delete the files <i>\src\script\tmp\moc\debug_shared\mocinclude.tmp</i> and <i>\src\script\tmp\moc\release_shared\mocinclude.tmp</i> and restart nmake. For more info, please see [http://bugreports.qt.nokia.com/browse/QTBUG-6470 QTBug 6470]].
 
#* Note: If you encounter the following error <code>api\qscriptextensionplugin.h(43): Error: Undefined interface,</code>, delete the files <i>\src\script\tmp\moc\debug_shared\mocinclude.tmp</i> and <i>\src\script\tmp\moc\release_shared\mocinclude.tmp</i> and restart nmake. For more info, please see [http://bugreports.qt.nokia.com/browse/QTBUG-6470 QTBug 6470]].

Latest revision as of 07:47, 14 June 2013

Home < Documentation < 4.2 < Developers < Build Instructions < Prerequisites < Qt

For the latest Slicer developers documentation, visit the Nightly page.

Binary vs build-from-source ?

If you build Slicer on ...

Linux

Mac

  • To use QtCreator and the Slicer designer plugins, a possible option is to build QtCreator against the installed Qt libraries. See discussion on the mailing list.

Windows

Debug (32 and 64-bit) or Release (64-bit)

Note Using the Qt Designer on Windows requires that the Slicer plugins are in the same mode as Qt. If Qt was compiled in Release mode (default), Slicer would have to be compiled in Release mode as well. However if Qt is compiled in Debug mode only, Slicer has to be compiled in Debug too. When Qt is in "Release and Debug" mode only the Release version of Designer.exe is generated, Slicer would have to be compiled in Release. So for developers, the Debug mode is recommended, this is why we detail the compilation of Qt below.

Release (32-bit)






Download Qt: Source and Binaries

Download links

The following table list the link allowing to download either the recommended source code or binary of Qt.

Linux Mac Windows
Tiger Leopard, SnowLeopard VS2008 VS2010
32bits 64bits 32bits 64bits 32bits 64bits 32bits 64bits
Qt source link 4.7.4 4.7.4 4.7.4 4.7.4 4.7.4
Qt binary link SDK-1.2 SDK-1.2 carbon_4.7.0 4.7.4
4.7.4 (optional: debug libs)
4.7.4 (src build only) 4.7.4 (src build only)

Note: You must first log in to your Nokia Developer account. Otherwise these links may appear to be broken.

Installation instruction

Linux

See Qt installation guide (4.7.4, Linux, 64-bit, Offline)

For debian/ubuntu you should be able to use:

sudo apt-get install qt4-dev-tools

which at the time of this writing will install qt4.8.1. To use this, you must override the cmake option which is set to 4.7.4.

Mac

TBD

Windows

TBD

Qt version specific issues

All

  • Qt 4.6.x on windows (and possibly in linux/mac): No image base64 support in QLabel/QTooltips (work around exists though)

Linux

  • NA

Mac

Windows

  • NA

How to change the minimum required version ?

  • It's indeed possible to use a different version, just be aware that moving forward in time, things may not work as expected. Even worse Slicer may simply fail to compile.
  • By configuring Slicer using -DSlicer_REQUIRED_QT_VERSION:STRING=4.7.0, you will be able to change the minimum required version.






Build instructions



Linux

  • Consider installing the following optional packages (libxt-dev libxrender-dev libxrandr-dev libxinerama-dev libxcursor-dev libfontconfig-dev libglib2.0-dev)
mkdir qt-everywhere-opensource-build-4.7.4
tar xvfz qt-everywhere-opensource-src-4.7.4.tar.gz
cd qt-everywhere-opensource-src-4.7.4
./configure -prefix ../qt-everywhere-opensource-build-4.7.4 -debug-and-release -opensource -confirm-license -no-qt3support -webkit -nomake examples -nomake demos
make -j8
make install

Note: Adapt -j8 with the number of core on your machine, a dual core should probably not do more than -j3, an 8 core machine can resonably go as much as -j12.

Mac

Similar to Linux configuration. Note that -arch x86_64 has been added.

For earlier versions of Xcode and Mac OS X

mkdir qt-everywhere-opensource-build-4.7.4
tar xvfz qt-everywhere-opensource-src-4.7.4.tar.gz
cd qt-everywhere-opensource-src-4.7.4
./configure -prefix ../qt-everywhere-opensource-build-4.7.4 -debug-and-release -opensource -confirm-license -no-qt3support -webkit -arch x86_64 -nomake examples -nomake demos -sdk /Developer/SDKs/MacOSX10.5.sdk/
make -j8
make install

On the latest Xcode versions (4.3) and Lion (10.7) the Developer directories have moved. The command is now:

./configure -prefix ../qt-everywhere-opensource-build-4.7.4 -debug-and-release -opensource -confirm-license -no-qt3support -arch x86_64 -nomake examples -nomake demos -webkit -sdk /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.7.sdk
  • Note:
    • If building against SDK 10.6 or 10.7, you will probably get link errors similar to what's described in [1] and [2]. The solution is probably to disable the corewlan module but didn't figure out to do that properly.

Windows

  1. Use a windows extracter to unzip the Qt archive, don't use cygwin unzip it.
  2. launch the msvc2008 command prompt (MSVC08->Tools->Visual Studio 2008 CommandPrompt) (or: launch cmd.exe and run vcvars32.bat) Note: Start x64 prompt from Start menu (don't start from inside visual studio or it will be an x86 32 bit shell). Menu item is "Visual Studio 2008 x64 Win64 Command Prompt"
  3. build with configure.exe -platform win32-msvc2008 -opensource -confirm-license -debug -webkit -nomake examples -nomake demos
    • When asked, choose open source license type (o), then accept the license (y)
    • Note: the option -prefix doesn't work on Windows.
    • Note: According to [3] Qt does not support msvc2008 on windows xp. However, running configure.exe with no -platform argument seems to work. If you run configure with the -platform argument first by mistake, and if configure -clean doesn't work, then you may need to start from a fresh extraction from the .zip archive before running configure.exe again with no -platform, unless you can run nmake with the config clean target.
    • Note: for Microsoft Visual Studio 2010 users, Qt 4.6.3 is hard to configure with MSVC2010, use Qt 4.7.x instead. Build with set QMAKESPEC=win32-msvc2010 and configure -platform win32-msvc2010 -debug
  4. run nmake
    • Note: building with webkit support requires that src/3rdparty/webkit/WebCore/tmp/moc/{debug,release}_shared/mocinclude.tmp be removed. else you will get linker errors like QNetworkReplyHandler.obj : error LNK2001: unresolved external symbol "public: virtual struct QMetaObject const * __thiscall WebCore::FormDataIODevice::metaObject(void)const (?metaObject@FormDataIODevice@WebCore@@UBEPBUQMetaObject@@XZ)
    • Note: If you encounter the following error api\qscriptextensionplugin.h(43): Error: Undefined interface,, delete the files \src\script\tmp\moc\debug_shared\mocinclude.tmp and \src\script\tmp\moc\release_shared\mocinclude.tmp and restart nmake. For more info, please see QTBug 6470].